#/html/body/div[3]/div[2]/div/div[1]/div[4]/div[1]
#/html/body/div[3]/div[2]/div/div[1]/div[4]

import urllib.request
import urllib.parse
from lxml import etree
import pandas as pd

def query(url):
    # 请求地址
    #url = 'https://baike.baidu.com/item/%E5%8D%A1%E4%BF%84%E6%96%AF/10724560'
    # 请求头部
    headers = { 
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36' 
    }
    # 利用请求地址和请求头部构造请求对象
    req = urllib.request.Request(url=url, headers=headers, method='GET')
    # 发送请求，获得响应
    response = urllib.request.urlopen(req)
    # 读取响应，获得文本
    text = response.read().decode('utf-8')
    # 构造 _Element 对象
    html = etree.HTML(text)
    # 使用 xpath 匹配数据，得到匹配字符串列表
    sen_list = html.xpath('//div[contains(@class,"lemma-summary") or contains(@class,"lemmaWgt-lemmaSummary")]//text()') 
    # 过滤数据，去掉空白
    sen_list_after_filter = [item.strip('\n') for item in sen_list]
    # 将字符串列表连成字符串并返回
    return ''.join(sen_list_after_filter)

if __name__ == '__main__':
    url=pd.read_csv('raw_url.csv')
    text={'name':[],'text':[]}
    for line in zip(url['url'],url['name']):
        result = query(line[0])
        text['name'].append(line[1])
        text['text'].append(result)

    text = pd.DataFrame(text).drop_duplicates()
    text = text.to_csv('raw_text.csv', index=False, encoding='utf_8_sig')